searchNodes=[{"doc":"The Copeiro package provides assertion functions that will enhance your testing experience in Elixir","ref":"Copeiro.html","title":"Copeiro","type":"module"},{"doc":"Asserts that two lists matches Examples For the following examples left and right will be used to describe the expression assert_lists left OPERATOR right All elements of left are also elements of right iex&gt; assert_lists [ 1 , 2 ] in [ 0 , 2 , 1 , 3 ] true iex&gt; assert_lists [ { :a , 1 } , { :c , 3 } ] in [ { :a , 1 } , { :b , 2 } , { :c , 3 } ] true left and right has no element in common iex&gt; assert_lists [ 1 , 2 ] not in [ 3 , 4 ] true iex&gt; assert_lists [ %{ c : 3 } , %{ d : 4 } ] not in [ %{ a : 1 } , %{ b : 2 } ] true Asserts that two lists match in any order iex&gt; assert_lists [ 1 , 2 , 3 ] == [ 2 , 1 , 3 ] , any_order : true true iex&gt; assert_lists [ { :a , 0 } , { :b , 1 } , { :c , 3 } ] == [ { :a , 0 } , { :c , 3 } , { :b , 1 } ] , any_order : true true Asserting lists of maps/structs iex&gt; assert_lists [ %{ a : 1 } , %{ a : 2 } ] in [ %{ a : 1 , b : 1 } , %{ a : 2 , b : 2 } , %{ a : 3 , b : 3 } ] , keys : [ :a ] true iex&gt; assert_lists [ %{ a : 1 } , %{ a : 2 } ] == [ %{ a : 2 , b : 2 } , %{ a : 1 , b : 1 } ] , keys : [ :a ] , any_order : true true","ref":"Copeiro.html#assert_lists/2","title":"Copeiro.assert_lists/2","type":"macro"},{"doc":"A wrapper over ExUnit.Case with Copeiro assertions","ref":"Copeiro.Case.html","title":"Copeiro.Case","type":"module"},{"doc":"Copeiro","ref":"readme.html","title":"Copeiro","type":"extras"},{"doc":"Very often we need to iterate and transform results while writing tests and asserting lists. This data manipulation inside test statements becomes a repetitive task as the project grows. Making tests less readable and increasing the chances of mistakes. The Copeiro main goal is to extend the ExUnit with an idiomatic DSL that seamless integrates to it. assert_lists [ { :c , 3 } , { :a , 1 } ] in [ { :c , 3 } , { :b , 2 } , { :a , 1 } ]","ref":"readme.html#motivation","title":"Copeiro - Motivation","type":"extras"},{"doc":"def deps do [ { :copeiro , &quot;~&gt; 0.1.1&quot; , only : :test } ] end","ref":"readme.html#installation","title":"Copeiro - Installation","type":"extras"},{"doc":"Using Copeiro in a test file def HelloWorldTest do use ExUnit.Case , async : true import Copeiro # ... end Adding Copeiro to your CaseTemplate (recommended) defmodule MyCase do use ExUnit.CaseTemplate using do quote do # This code is injected into every case that calls &quot;use MyCase&quot; import Copeiro end end end","ref":"readme.html#usage","title":"Copeiro - Usage","type":"extras"},{"doc":"For the following examples LEFT and RIGHT will be used to describe the expression: assert_lists LEFT OPERATOR RIGHT All elements of LEFT are also elements of RIGHT iex&gt; assert_lists [ 1 , 2 ] in [ 0 , 2 , 1 , 3 ] true iex&gt; assert_lists [ { :b , 2 } , { :a , 1 } ] in [ { :a , 1 } , { :b , 2 } , { :c , 3 } ] true LEFT and RIGHT has no element in common iex&gt; assert_lists [ 1 , 2 ] not in [ 3 , 4 ] true iex&gt; assert_lists [ %{ c : 3 } , %{ d : 4 } ] not in [ %{ a : 1 } , %{ b : 2 } ] true Asserts that two lists match in any order iex&gt; assert_lists [ 1 , 2 , 3 ] == [ 2 , 1 , 3 ] , any_order : true true iex&gt; assert_lists [ { :a , 0 } , { :b , 1 } , { :c , 3 } ] == [ { :a , 0 } , { :c , 3 } , { :b , 1 } ] , any_order : true true Asserting lists of maps/structs When asserting maps and or structs you can compose the expression with keys iex&gt; assert_lists [ %{ a : 1 } , %{ a : 2 } ] in [ %{ a : 1 , b : 1 } , %{ a : 2 , b : 2 } , %{ a : 3 , b : 3 } ] , keys : [ :a ] true iex&gt; assert_lists [ % Person { name : &quot;john&quot; , age : 20 } ] == [ % Person { name : &quot;Jane&quot; , age : 20 } ] , keys : [ :age ] true","ref":"readme.html#examples","title":"Copeiro - Examples","type":"extras"},{"doc":"assert_lists [ %{ d : 4 } , %{ a : 1 } ] not in [ %{ a : 1 } , %{ b : 2 } ] match succeeded , but should have failed value : %{ a : 1 } left : [ %{ d : 4 } , %{ a : 1 } ] right : [ %{ a : 1 } , %{ b : 2 } ]","ref":"readme.html#helpful-error-messages","title":"Copeiro - Helpful error messages","type":"extras"},{"doc":"MIT License Copyright (c) 2021 Felipe Beline Baravieira","ref":"readme.html#license","title":"Copeiro - License","type":"extras"}]